import { AiAgent, AiAgentOpts } from './create-agent.ts';
export enum AgentMangerStatus {
  init = 'i',
  ready = 'r',
  error = 'e',
}
export class AgentManger {
  agents: AiAgent[] = [];
  staus: AgentMangerStatus = AgentMangerStatus.init;
  constructor() {}
  addAgent(agent: AiAgent) {
    this.agents.push(agent);
  }
  getAgent(id: string) {
    const agent = this.agents.find((agent) => agent.id === id);
    return agent;
  }
  removeAgent(id: string) {
    this.agents = this.agents.filter((agent) => agent.id !== id);
  }
  createAgent(opts: AiAgentOpts) {
    if (!opts.id) {
      const agent = new AiAgent(opts);
      this.addAgent(agent);
      return agent;
    }
    const agent = this.agents.find((agent) => agent.id === opts.id);
    if (!agent) {
      const agent = new AiAgent(opts);
      this.addAgent(agent);
      return agent;
    }
    return agent;
  }
  /**
   * 临时创建一个agent
   * @param opts
   * @returns
   */
  newAgent(opts: AiAgentOpts) {
    return new AiAgent(opts);
  }
  createAgentList(opts: AiAgentOpts[]) {
    if (this.staus === AgentMangerStatus.init) {
      return;
    }
    this.staus = AgentMangerStatus.ready;
    return opts.map((opt) => this.createAgent(opt));
  }
}
export const agentManger = new AgentManger();
