// admin 需要最后运行，并在route中进行过滤。
import { Route } from '@abearxiong/router';
import { router } from '../modules/router.ts';
import { manager, updateNewCode, removeCode, stopCode, startCode } from './dashboard/manager.ts';
import { loadOne } from './dashboard/load.ts';
import { RouterCodeModel } from '../models/code.ts';
// get manager status
export const managerRouter = new Route('admin', 'getManagerStatus');
managerRouter.run = async (ctx) => {
  ctx.body = {
    status: manager.loaded,
    msg: 'system is running, and load manager success.',
  };
  return ctx;
};
router.add(managerRouter);

// get manager list
export const managerList = new Route('admin', 'getManagerList');
managerList.run = async (ctx) => {
  ctx.body = manager.list;
  const routerList = router.getList().filter((r) => !r.path.startsWith('admin'));
  ctx.body = {
    list: manager.list,
    routerList,
  };
  return ctx;
};
router.add(managerList);

// get manager one
export const managerOne = new Route('admin', 'getManagerOne');
managerOne.run = async (ctx) => {
  const verfiy = ctx.currentRoute.verify(ctx);
  if (verfiy) return;

  const { id } = ctx.query;
  const code = manager.list.find((c) => c.id === id);
  if (code) {
    ctx.body = code;
  } else {
    ctx.body = 'not found';
    ctx.code = 404;
  }

  return ctx;
};
managerOne.validator = {
  id: {
    type: 'string',
    required: true,
  },
};

router.add(managerOne);
