import path from 'path';
export const getRequire = () => {
  return eval('require') as NodeRequire;
};

export const directoryPath = path.resolve(__dirname);

export const defaultImportModules = [
  {
    name: 'sequelize',
    version: '^6.6.5',
  },
  {
    name: 'pg',
    version: '^8.12.1',
  },
];

export const dynamicImport = async (name: string) => {
  // const nodeModules = path.resolve(directoryPath, 'node_modules');
  // const nodeName = path.resolve(nodeModules, name);
  const require = getRequire();
  console.log(`Dynamic import module ${name}`);
  try {
    const nodeCache = require.cache[require.resolve(name)];
    if (nodeCache) {
      console.log(`${name} is cached`);
    }
    return require(name);
  } catch (e) {
    console.error(`Failed to import module ${name}: ${e.message}`);
    throw `Failed to import module ${name}: ${e.message}`;
  }
};
